(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     31050,        729]
NotebookOptionsPosition[     30618,        710]
NotebookOutlinePosition[     31071,        728]
CellTagsIndexPosition[     31028,        725]
WindowFrame->Normal
ContainsDynamic->True *)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{
  RowBox[{"Animate", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ushift", "=", "1.1"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Oa", "=", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Ob", "=", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Oc", "=", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Od", "=", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"OA", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0"}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"OB", "=", 
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"OC", "=", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", 
        RowBox[{"-", "1"}], ",", "0"}], "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"OD", "=", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", 
        RowBox[{"-", "1"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{"definition", " ", "of", " ", "tetrahedron"}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"tetrahedron", "[", "vecs_", "]"}], ":=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Polygon", "[", 
         RowBox[{"Drop", "[", 
          RowBox[{"vecs", ",", 
           RowBox[{"{", "k", "}"}]}], "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"k", ",", "1", ",", "4"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{"definition", " ", "of", " ", "projection"}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"proj", "[", "x_", "]"}], ":=", 
      RowBox[{"Switch", "[", "\[IndentingNewLine]", 
       RowBox[{"mode", ",", "\[IndentingNewLine]", "1", ",", 
        RowBox[{"x", "[", 
         RowBox[{"[", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", "3"}], "}"}], "]"}], "]"}], ",", 
        "\[IndentingNewLine]", "2", ",", 
        RowBox[{"x", "[", 
         RowBox[{"[", 
          RowBox[{"{", 
           RowBox[{"1", ",", "2", ",", "4"}], "}"}], "]"}], "]"}], ",", 
        "\[IndentingNewLine]", "3", ",", 
        RowBox[{
         RowBox[{"1", "/", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"x", "[", 
             RowBox[{"[", "4", "]"}], "]"}], "+", "ushift"}], ")"}]}], 
         RowBox[{"x", "[", 
          RowBox[{"[", 
           RowBox[{"{", 
            RowBox[{"1", ",", "2", ",", "3"}], "}"}], "]"}], "]"}]}]}], 
       "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{
       "Rotation", " ", "matrix", " ", "\"\<ON\>\"", " ", "the", " ", "plane",
         " ", "\[Pi]", " ", "spanned", " ", "by", " ", "m"}], "=", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], "&"}], "n"}], 
        "=", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}]}]}], "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
      "r", " ", "has", " ", "same", " ", "length", " ", "as", " ", "n", " ", 
       "and", " ", "orthogonal", " ", "to", " ", "n", " ", "on", " ", 
       "\[Pi]"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{"p", ",", 
       RowBox[{
       "q", " ", "are", " ", "orthogonal", " ", "vectors", " ", "against", 
        " ", 
        RowBox[{"\[Pi]", ".", " ", "They"}], " ", "can", " ", "have", " ", 
        "arbitrary", " ", 
        RowBox[{"length", "."}]}]}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{"n", "=", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1", ",", "1"}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"r", "=", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "1"}], "/", 
        RowBox[{"Sqrt", "[", "3", "]"}]}], 
       RowBox[{"{", 
        RowBox[{"1", ",", "1", ",", "1", ",", 
         RowBox[{"-", "3"}]}], "}"}]}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"p", "=", 
      RowBox[{"{", 
       RowBox[{"2", ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{"-", "1"}], ",", "0"}], "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"q", "=", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", 
        RowBox[{"-", "1"}], ",", "0"}], "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Rot", "[", "\[Theta]_", "]"}], ":=", 
      RowBox[{"(", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"P", ":=", 
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"n", ",", "r", ",", "p", ",", "q"}], "}"}], "]"}]}], ";", 
        RowBox[{"P", ".", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Cos", "[", "\[Theta]", "]"}], ",", 
             RowBox[{"-", 
              RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ",", "0", ",", "0"}], 
            "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Sin", "[", "\[Theta]", "]"}], ",", 
             RowBox[{"Cos", "[", "\[Theta]", "]"}], ",", "0", ",", "0"}], 
            "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], ".", 
         
         RowBox[{"Inverse", "[", "P", "]"}]}]}], "\[IndentingNewLine]", 
       ")"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"ABCD0", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"OA", ",", "OB", ",", "OC", ",", "OD"}], "}"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"ABCD", ":=", 
      RowBox[{
       RowBox[{"Rot", "[", "t", "]"}], ".", "ABCD0"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"vecsABCD", ":=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"proj", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"Transpose", "[", "ABCD", "]"}], ")"}], "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"k", ",", "1", ",", "4"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"polyABCD", ":=", 
      RowBox[{"tetrahedron", "[", "vecsABCD", "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"abcd0", "=", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"Oa", ",", "Ob", ",", "Oc", ",", "Od"}], "}"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"abcd", ":=", 
      RowBox[{
       RowBox[{"Rot", "[", "t", "]"}], ".", "abcd0"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"vecsabcd", ":=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"proj", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"Transpose", "[", "abcd", "]"}], ")"}], "[", 
          RowBox[{"[", "k", "]"}], "]"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"k", ",", "1", ",", "4"}], "}"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"polyabcd", ":=", 
      RowBox[{"tetrahedron", "[", "vecsabcd", "]"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"outoftheworld", "=", 
      RowBox[{"Point", "[", 
       RowBox[{"{", 
        RowBox[{"200", ",", "0", ",", "0"}], "}"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"segs", ":=", 
      RowBox[{"If", "[", 
       RowBox[{"showsegs", ",", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"Line", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{
               "vecsABCD", "\[LeftDoubleBracket]", "j", 
                "\[RightDoubleBracket]"}], ",", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"Drop", "[", 
                  RowBox[{"vecsabcd", ",", 
                   RowBox[{"{", "j", "}"}]}], "]"}], ")"}], "[", 
                RowBox[{"[", "k", "]"}], "]"}]}], "}"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"k", ",", "1", ",", "3"}], "}"}]}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "1", ",", "4"}], "}"}]}], "]"}], ",", 
        "outoftheworld"}], "]"}]}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"ptA", ":=", 
        RowBox[{
        "vecsABCD", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
       ";", 
       RowBox[{"ptB", ":=", 
        RowBox[{
        "vecsABCD", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
       ";", 
       RowBox[{"ptC", ":=", 
        RowBox[{
        "vecsABCD", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}], 
       ";", 
       RowBox[{"ptD", ":=", 
        RowBox[{
        "vecsABCD", "\[LeftDoubleBracket]", "4", "\[RightDoubleBracket]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"pta", ":=", 
        RowBox[{
        "vecsabcd", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
       ";", 
       RowBox[{"ptb", ":=", 
        RowBox[{
        "vecsabcd", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
       ";", 
       RowBox[{"ptc", ":=", 
        RowBox[{
        "vecsabcd", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}], 
       ";", 
       RowBox[{"ptd", ":=", 
        RowBox[{
        "vecsabcd", "\[LeftDoubleBracket]", "4", "\[RightDoubleBracket]"}]}], 
       ";"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"font", "=", "12"}], ";", "\[IndentingNewLine]", 
     RowBox[{"txtA", ":=", 
      RowBox[{"Text", "[", 
       RowBox[{
        RowBox[{"Style", "[", 
         RowBox[{"\"\<A\>\"", ",", "font"}], "]"}], ",", 
        RowBox[{
        "vecsABCD", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"txtB", ":=", 
      RowBox[{"Text", "[", 
       RowBox[{
        RowBox[{"Style", "[", 
         RowBox[{"\"\<B\>\"", ",", "font"}], "]"}], ",", 
        RowBox[{
        "vecsABCD", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"txtC", ":=", 
      RowBox[{"Text", "[", 
       RowBox[{
        RowBox[{"Style", "[", 
         RowBox[{"\"\<C\>\"", ",", "font"}], "]"}], ",", 
        RowBox[{
        "vecsABCD", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"txtD", ":=", 
      RowBox[{"Text", "[", 
       RowBox[{
        RowBox[{"Style", "[", 
         RowBox[{"\"\<D\>\"", ",", "font"}], "]"}], ",", 
        RowBox[{
        "vecsABCD", "\[LeftDoubleBracket]", "4", "\[RightDoubleBracket]"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"txta", ":=", 
      RowBox[{"Text", "[", 
       RowBox[{
        RowBox[{"Style", "[", 
         RowBox[{"\"\<a\>\"", ",", "font"}], "]"}], ",", 
        RowBox[{
        "vecsabcd", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"txtb", ":=", 
      RowBox[{"Text", "[", 
       RowBox[{
        RowBox[{"Style", "[", 
         RowBox[{"\"\<b\>\"", ",", "font"}], "]"}], ",", 
        RowBox[{
        "vecsabcd", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"txtc", ":=", 
      RowBox[{"Text", "[", 
       RowBox[{
        RowBox[{"Style", "[", 
         RowBox[{"\"\<c\>\"", ",", "font"}], "]"}], ",", 
        RowBox[{
        "vecsabcd", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"txtd", ":=", 
      RowBox[{"Text", "[", 
       RowBox[{
        RowBox[{"Style", "[", 
         RowBox[{"\"\<d\>\"", ",", "font"}], "]"}], ",", 
        RowBox[{
        "vecsabcd", "\[LeftDoubleBracket]", "4", "\[RightDoubleBracket]"}]}], 
       "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"names", ":=", 
      RowBox[{"{", 
       RowBox[{
       "txtA", ",", "txtB", ",", "txtC", ",", "txtD", ",", "txta", ",", 
        "txtb", ",", "txtc", ",", "txtd"}], "}"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"myrange", ":=", 
      RowBox[{"Switch", "[", 
       RowBox[{"mode", ",", "1", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1."}], ",", "1."}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1."}], ",", "1."}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1."}], ",", "1."}], "}"}]}], "}"}], ",", 
        "\[IndentingNewLine]", "2", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1."}], ",", "1."}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1."}], ",", "1."}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}], ",", "3", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1.4"}], ",", "1.4"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1.4"}], ",", "1.4"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1.4"}], ",", "1.4"}], "}"}]}], "}"}]}], "]"}]}], 
     ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"Graphics3D", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Opacity", "[", "0.3", "]"}], ",", 
         RowBox[{"(*", 
          RowBox[{
           RowBox[{"Text", "[", 
            RowBox[{"\"\<L\>\"", ",", 
             RowBox[{
              RowBox[{"1", "/", "u1"}], " ", 
              RowBox[{"OL", "[", 
               RowBox[{"[", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "2", ",", "3"}], "}"}], "]"}], "]"}]}]}], 
            "]"}], ",", 
           RowBox[{"Text", "[", 
            RowBox[{"\"\<K\>\"", ",", 
             RowBox[{
              RowBox[{"1", "/", "u1"}], " ", 
              RowBox[{"OK", "[", 
               RowBox[{"[", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "2", ",", "3"}], "}"}], "]"}], "]"}]}]}], 
            "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Text", "[", 
            RowBox[{"\"\<M\>\"", ",", 
             RowBox[{
              RowBox[{"1", "/", "u1"}], " ", 
              RowBox[{"OM", "[", 
               RowBox[{"[", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "2", ",", "3"}], "}"}], "]"}], "]"}]}]}], 
            "]"}], ",", 
           RowBox[{"Text", "[", 
            RowBox[{"\"\<A\>\"", ",", 
             RowBox[{
              RowBox[{"1", "/", "u1"}], " ", 
              RowBox[{"OA", "[", 
               RowBox[{"[", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "2", ",", "3"}], "}"}], "]"}], "]"}]}]}], 
            "]"}], ","}], "*)"}], "\[IndentingNewLine]", "Red", ",", 
         "polyABCD", ",", "Blue", ",", "polyabcd", ",", "Black", ",", 
         RowBox[{"Opacity", "[", "1", "]"}], ",", "names", ",", 
         RowBox[{"Green", "//", "Darker"}], ",", "Dashed", ",", "segs"}], 
        "}"}], "\[IndentingNewLine]", ",", 
       RowBox[{"PlotRange", "\[Rule]", "myrange"}], ",", 
       RowBox[{"Boxed", "\[Rule]", "False"}]}], "]"}]}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", "controllers", "*)"}], "\[IndentingNewLine]", ",", 
    RowBox[{"{", 
     RowBox[{"t", ",", "0", ",", " ", 
      RowBox[{
       RowBox[{"1", "/", "3"}], " ", "Pi"}]}], "}"}], ",", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"ushift", ",", "1.1"}], "}"}], ",", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"0.05", " ", "k"}], ",", 
          RowBox[{"{", 
           RowBox[{"k", ",", "0", ",", "40"}], "}"}]}], "]"}], ",", 
        RowBox[{"ControlType", "\[Rule]", "PopupMenu"}]}], "}"}], ","}], 
     "*)"}], "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"mode", ",", "3", ",", "\"\<projection style\>\""}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"1", "->", "\"\<(x,y,z,u)\[Rule](x,y,z)\>\""}], ",", 
        RowBox[{"2", "->", "\"\<(x,y,z,u)\[Rule](x,y,u)\>\""}], ",", 
        RowBox[{
        "3", "->", 
         "\"\<(x,y,z,u)\[Rule](\!\(\*FractionBox[\(x\), \
\(u\)]\),\!\(\*FractionBox[\(y\), \(u\)]\),\!\(\*FractionBox[\(z\), \(u\)]\))\
\>\""}]}], "}"}], ",", 
      RowBox[{"ControlType", "\[Rule]", "PopupMenu"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"showsegs", ",", 
      RowBox[{"{", 
       RowBox[{"True", ",", "False"}], "}"}], ",", 
      RowBox[{"ControlType", "->", "Checkbox"}]}], "}"}]}], "]"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.536447196421875*^9, 3.536447290375*^9}, {
   3.53644829346875*^9, 3.53644829571875*^9}, {3.536448333109375*^9, 
   3.53644836165625*^9}, {3.536448393875*^9, 3.53644840628125*^9}, {
   3.536448439015625*^9, 3.53644843959375*^9}, {3.5364486131875*^9, 
   3.536448614734375*^9}, {3.536448648171875*^9, 3.53644864996875*^9}, {
   3.53644870921875*^9, 3.536448709515625*^9}, {3.536448763484375*^9, 
   3.536448764*^9}, 3.536448849640625*^9, {3.536448911140625*^9, 
   3.5364489349375*^9}, {3.536449058078125*^9, 3.53644906021875*^9}, {
   3.536449136828125*^9, 3.536449138859375*^9}, {3.536449211546875*^9, 
   3.53644925790625*^9}, {3.536449314046875*^9, 3.53644931775*^9}, {
   3.536449617625*^9, 3.536449617671875*^9}, {3.53644968709375*^9, 
   3.536449714625*^9}, {3.5364498005625*^9, 3.536449830890625*^9}, {
   3.536449963265625*^9, 3.536450096546875*^9}, {3.536453062375*^9, 
   3.536453131484375*^9}, {3.53645316440625*^9, 3.536453206*^9}, {
   3.536453246484375*^9, 3.5364533581875*^9}, {3.53645343103125*^9, 
   3.536453434109375*^9}, {3.536453548609375*^9, 3.536453549109375*^9}, {
   3.536453746921875*^9, 3.536453927125*^9}, {3.5364539868125*^9, 
   3.53645406921875*^9}, {3.53645411896875*^9, 3.5364541280625*^9}, 
   3.536454239921875*^9, {3.5364543124375*^9, 3.53645431296875*^9}, {
   3.536454354875*^9, 3.5364544050625*^9}, {3.536454441578125*^9, 
   3.53645444215625*^9}, {3.536454568109375*^9, 3.536454589671875*^9}, {
   3.5364546715*^9, 3.536454734484375*^9}, {3.536454801765625*^9, 
   3.5364548805625*^9}, {3.53645501221875*^9, 3.536455166234375*^9}, {
   3.536455246390625*^9, 3.536455314328125*^9}, {3.536455361109375*^9, 
   3.536455435609375*^9}, {3.53645554371875*^9, 3.53645558921875*^9}, {
   3.536455624421875*^9, 3.536455632484375*^9}, {3.53645578840625*^9, 
   3.536455790640625*^9}, {3.53645582196875*^9, 3.53645584796875*^9}, {
   3.5364559085625*^9, 3.53645591046875*^9}, {3.53645594890625*^9, 
   3.536455950640625*^9}, {3.536455985796875*^9, 3.53645599109375*^9}, {
   3.53645604959375*^9, 3.536456127609375*^9}, {3.53645635240625*^9, 
   3.53645635821875*^9}, {3.536456404234375*^9, 3.5364565575*^9}, 
   3.536456622375*^9, {3.536456656671875*^9, 3.53645665959375*^9}, {
   3.53645671921875*^9, 3.53645672946875*^9}, {3.536456788734375*^9, 
   3.536456789359375*^9}, {3.53645682346875*^9, 3.536456860625*^9}, {
   3.53645690640625*^9, 3.53645696390625*^9}, 3.5364571848125*^9, {
   3.536457261859375*^9, 3.536457307*^9}, {3.53645736853125*^9, 
   3.5364573726875*^9}, {3.536460770890625*^9, 3.5364608645625*^9}, {
   3.536460975515625*^9, 3.53646107803125*^9}, {3.5364613466875*^9, 
   3.536461367890625*^9}, {3.53646141725*^9, 3.53646147228125*^9}, {
   3.536461832734375*^9, 3.5364619303125*^9}, {3.536461968828125*^9, 
   3.536462117453125*^9}, {3.536462204015625*^9, 3.53646221303125*^9}, {
   3.53646234315625*^9, 3.53646234725*^9}, {3.53646247459375*^9, 
   3.536462475859375*^9}, {3.53646254790625*^9, 3.536462614921875*^9}, {
   3.53646277853125*^9, 3.536462788515625*^9}, {3.536463023671875*^9, 
   3.536463077703125*^9}, {3.536463129921875*^9, 3.53646324175*^9}, {
   3.536463282109375*^9, 3.536463286578125*^9}, {3.536463324953125*^9, 
   3.53646332634375*^9}, {3.536463375671875*^9, 3.536463391234375*^9}, {
   3.536463427953125*^9, 3.536463507546875*^9}, {3.53646354009375*^9, 
   3.53646355003125*^9}, {3.536463581984375*^9, 3.53646359440625*^9}, {
   3.536463668453125*^9, 3.536463686015625*^9}, {3.5364637185625*^9, 
   3.5364637395*^9}, {3.5364637701875*^9, 3.53646388353125*^9}, {
   3.53646393546875*^9, 3.53646413253125*^9}, {3.536464168359375*^9, 
   3.536464171890625*^9}, {3.536464213765625*^9, 3.536464290828125*^9}, {
   3.536464333078125*^9, 3.5364643418125*^9}, {3.536464400234375*^9, 
   3.53646442675*^9}, {3.536464475796875*^9, 3.536464621875*^9}, {
   3.5364646731875*^9, 3.536464776234375*^9}, {3.5364649314375*^9, 
   3.5364649356875*^9}, {3.536465058265625*^9, 3.5364652339375*^9}, {
   3.536465269796875*^9, 3.536465328984375*^9}, {3.53646536028125*^9, 
   3.53646538365625*^9}, {3.53646542553125*^9, 3.536465572796875*^9}, {
   3.53646560728125*^9, 3.5364656299375*^9}, {3.536465679828125*^9, 
   3.536465680765625*^9}, {3.536465736390625*^9, 3.536465810625*^9}, {
   3.536465885796875*^9, 3.53646602103125*^9}, {3.53646609296875*^9, 
   3.5364661215625*^9}, {3.53646616490625*^9, 3.53646616553125*^9}, {
   3.536466210734375*^9, 3.53646621134375*^9}}],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`mode$$ = 3, $CellContext`showsegs$$ = 
    True, $CellContext`t$$ = 0., Typeset`show$$ = True, 
    Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{
      Hold[$CellContext`t$$], 0, Rational[1, 3] Pi}, {{
       Hold[$CellContext`mode$$], 3, "projection style"}, {
      1 -> "(x,y,z,u)\[Rule](x,y,z)", 2 -> "(x,y,z,u)\[Rule](x,y,u)", 3 -> 
       "(x,y,z,u)\[Rule](\!\(\*FractionBox[\(x\), \(u\)]\),\!\(\*FractionBox[\
\(y\), \(u\)]\),\!\(\*FractionBox[\(z\), \(u\)]\))"}}, {
      Hold[$CellContext`showsegs$$], {True, False}}}, Typeset`size$$ = {
    540., {288., 298.}}, Typeset`update$$ = 0, Typeset`initDone$$, 
    Typeset`skipInitDone$$ = True, $CellContext`t$138806$$ = 
    0, $CellContext`mode$138807$$ = False, $CellContext`showsegs$138808$$ = 
    False}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, 
      "Variables" :> {$CellContext`mode$$ = 3, $CellContext`showsegs$$ = 
        True, $CellContext`t$$ = 0}, "ControllerVariables" :> {
        Hold[$CellContext`t$$, $CellContext`t$138806$$, 0], 
        Hold[$CellContext`mode$$, $CellContext`mode$138807$$, False], 
        Hold[$CellContext`showsegs$$, $CellContext`showsegs$138808$$, False]},
       "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, 
      "Body" :> ($CellContext`ushift = 
        1.1; $CellContext`Oa = {1, 0, 0, 0}; $CellContext`Ob = {0, 1, 0, 
         0}; $CellContext`Oc = {0, 0, 1, 0}; $CellContext`Od = {0, 0, 0, 
         1}; $CellContext`OA = {-1, 0, 0, 0}; $CellContext`OB = {0, -1, 0, 
         0}; $CellContext`OC = {0, 0, -1, 0}; $CellContext`OD = {0, 0, 
         0, -1}; $CellContext`tetrahedron[
          Pattern[$CellContext`vecs, 
           Blank[]]] := Table[
          Polygon[
           Drop[$CellContext`vecs, {$CellContext`k}]], {$CellContext`k, 1, 
           4}]; $CellContext`proj[
          Pattern[$CellContext`x$, 
           Blank[]]] := Switch[$CellContext`mode$$, 1, 
          Part[$CellContext`x$, {1, 2, 3}], 2, 
          Part[$CellContext`x$, {1, 2, 4}], 
          3, (1/(Part[$CellContext`x$, 4] + $CellContext`ushift)) 
          Part[$CellContext`x$, {1, 2, 3}]]; $CellContext`n = {1, 1, 1, 
         1}; $CellContext`r = ((-1)/Sqrt[3]) {1, 1, 1, -3}; $CellContext`p = {
         2, -1, -1, 0}; $CellContext`q = {0, 1, -1, 0}; $CellContext`Rot[
          Pattern[$CellContext`\[Theta], 
           Blank[]]] := ($CellContext`P := 
          Transpose[{$CellContext`n, $CellContext`r, $CellContext`p, \
$CellContext`q}]; Dot[$CellContext`P, {{
             Cos[$CellContext`\[Theta]], -Sin[$CellContext`\[Theta]], 0, 0}, {
            
             Sin[$CellContext`\[Theta]], 
             Cos[$CellContext`\[Theta]], 0, 0}, {0, 0, 1, 0}, {0, 0, 0, 1}}, 
           Inverse[$CellContext`P]]); $CellContext`ABCD0 = 
        Transpose[{$CellContext`OA, $CellContext`OB, $CellContext`OC, \
$CellContext`OD}]; $CellContext`ABCD := Dot[
          $CellContext`Rot[$CellContext`t$$], $CellContext`ABCD0]; \
$CellContext`vecsABCD := Table[
          $CellContext`proj[
           Part[
            Transpose[$CellContext`ABCD], $CellContext`k]], {$CellContext`k, 
           1, 4}]; $CellContext`polyABCD := \
$CellContext`tetrahedron[$CellContext`vecsABCD]; $CellContext`abcd0 = 
        Transpose[{$CellContext`Oa, $CellContext`Ob, $CellContext`Oc, \
$CellContext`Od}]; $CellContext`abcd := Dot[
          $CellContext`Rot[$CellContext`t$$], $CellContext`abcd0]; \
$CellContext`vecsabcd := Table[
          $CellContext`proj[
           Part[
            Transpose[$CellContext`abcd], $CellContext`k]], {$CellContext`k, 
           1, 4}]; $CellContext`polyabcd := \
$CellContext`tetrahedron[$CellContext`vecsabcd]; $CellContext`outoftheworld = 
        Point[{200, 0, 0}]; $CellContext`segs := If[$CellContext`showsegs$$, 
          Table[
           Table[
            Line[{
              Part[$CellContext`vecsABCD, $CellContext`j], 
              Part[
               
               Drop[$CellContext`vecsabcd, {$CellContext`j}], \
$CellContext`k]}], {$CellContext`k, 1, 3}], {$CellContext`j, 1, 
            4}], $CellContext`outoftheworld]; $CellContext`font = 
        12; $CellContext`txtA := Text[
          Style["A", $CellContext`font], 
          Part[$CellContext`vecsABCD, 1]]; $CellContext`txtB := Text[
          Style["B", $CellContext`font], 
          Part[$CellContext`vecsABCD, 2]]; $CellContext`txtC := Text[
          Style["C", $CellContext`font], 
          Part[$CellContext`vecsABCD, 3]]; $CellContext`txtD := Text[
          Style["D", $CellContext`font], 
          Part[$CellContext`vecsABCD, 4]]; $CellContext`txta := Text[
          Style["a", $CellContext`font], 
          Part[$CellContext`vecsabcd, 1]]; $CellContext`txtb := Text[
          Style["b", $CellContext`font], 
          Part[$CellContext`vecsabcd, 2]]; $CellContext`txtc := Text[
          Style["c", $CellContext`font], 
          Part[$CellContext`vecsabcd, 3]]; $CellContext`txtd := Text[
          Style["d", $CellContext`font], 
          
          Part[$CellContext`vecsabcd, 
           4]]; $CellContext`names := {$CellContext`txtA, $CellContext`txtB, \
$CellContext`txtC, $CellContext`txtD, $CellContext`txta, $CellContext`txtb, \
$CellContext`txtc, $CellContext`txtd}; $CellContext`myrange := 
        Switch[$CellContext`mode$$, 1, {{-1., 1.}, {-1., 1.}, {-1., 1.}}, 
          2, {{-1., 1.}, {-1., 1.}, {-1, 1}}, 3, {{-1.4, 1.4}, {-1.4, 
          1.4}, {-1.4, 1.4}}]; Graphics3D[{
          Opacity[0.3], Red, $CellContext`polyABCD, 
          Blue, $CellContext`polyabcd, Black, 
          Opacity[1], $CellContext`names, 
          Darker[Green], Dashed, $CellContext`segs}, 
         PlotRange -> $CellContext`myrange, Boxed -> False]), 
      "Specifications" :> {{$CellContext`t$$, 0, Rational[1, 3] Pi, 
         AppearanceElements -> {
          "ProgressSlider", "PlayPauseButton", "FasterSlowerButtons", 
           "DirectionButton"}}, {{$CellContext`mode$$, 3, 
          "projection style"}, {
         1 -> "(x,y,z,u)\[Rule](x,y,z)", 2 -> "(x,y,z,u)\[Rule](x,y,u)", 3 -> 
          "(x,y,z,u)\[Rule](\!\(\*FractionBox[\(x\), \
\(u\)]\),\!\(\*FractionBox[\(y\), \(u\)]\),\!\(\*FractionBox[\(z\), \
\(u\)]\))"}, ControlType -> PopupMenu, 
         AppearanceElements -> {
          "ProgressSlider", "PlayPauseButton", "FasterSlowerButtons", 
           "DirectionButton"}}, {$CellContext`showsegs$$, {True, False}, 
         ControlType -> Checkbox, 
         AppearanceElements -> {
          "ProgressSlider", "PlayPauseButton", "FasterSlowerButtons", 
           "DirectionButton"}}}, 
      "Options" :> {
       ControlType -> Animator, AppearanceElements -> None, 
        SynchronousUpdating -> True, ShrinkingDelay -> 10.}, 
      "DefaultOptions" :> {}],
     ImageSizeCache->{610., {373.5, 380.5}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{{3.5364656331875*^9, 3.536465647828125*^9}, {
  3.536465739734375*^9, 3.53646581215625*^9}, {3.5364658450625*^9, 
  3.5364658613125*^9}, {3.536465894171875*^9, 3.536465905015625*^9}, {
  3.5364660221875*^9, 3.53646611434375*^9}, {3.5364661675*^9, 
  3.53646617390625*^9}, {3.5364662146875*^9, 3.53646621878125*^9}}]
}, Open  ]]
},
WindowSize->{1272, 903},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
Magnification:>FEPrivate`If[
  FEPrivate`Equal[FEPrivate`$VersionNumber, 6.], 1.5, 1.5 Inherited],
FrontEndVersion->"6.0 for Microsoft Windows (32-bit) (2008\:5e745\:670821\
\:65e5)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[602, 23, 22150, 533, 2287, "Input"],
Cell[22755, 558, 7847, 149, 779, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
